unit UTNode;
 // ,     TNode,  
interface

uses
  SysUtils,
  Classes;

type
  TIndex = #48..#255;  //    ,      
  TNode = class
  public
    FNext: array[TIndex] of TNode;
    FPoint: boolean;
    procedure Clear;
    constructor Create;
    destructor Destroy; override;
    function IsEmpty: boolean;
    procedure Print(S: TStrings);
    procedure RemoveStartedWith(const Wrd: string);
    procedure RemoveStartedWithR(var wrd:string);
  end;


implementation

///////   
procedure TNode.Clear;
var
  i: TIndex;
begin
  FPoint := false;
  for i := low(TIndex) to high(TIndex) do
    FNext[i].Free;
end;

// .      .
constructor TNode.Create;
var i:TIndex;
begin
  FPoint := false;
  for i := low(TIndex) to high(TIndex) do
    FNext[i]:=nil;
end;

/// 
destructor TNode.Destroy;
begin
  Clear;
  inherited Destroy;
end;

//     
function TNode.IsEmpty: boolean;
var
  i: TIndex;
begin
  if Self = nil then
    result := false else
  begin
    i := low(TIndex);
    result := (not FPoint);
    while result and (i < high(TIndex)) do
     if FNext[i] = nil then i := succ(i)
      else result := false;
    result:=result and (FNext[high(TIndex)]=nil);
  end;
end;

//     ,    Memo.Lines
procedure TNode.Print(S: TStrings);
var
  Wrd: string;
  Count, Size: integer;

  procedure AddChar(c: TIndex);
  begin
    inc(Count);
    if Count > Size then
    begin
      Size := Size * 2;
      SetLength(Wrd, Size);
    end;
    Wrd[Count] := C;
  end;

  procedure PrintNode(Node: TNode);
  var
    i: TIndex;
  begin
    if Node.FPoint then
      S.Add(Copy(Wrd, 1, Count));
    for i := low(TIndex) to high(TIndex) do
    if Node.FNext[i] <> nil then
    begin
      AddChar(i);
      PrintNode(Node.FNext[i]);
      dec(Count);
    end;
  end;

begin
  S.Clear;
  Wrd := ' ';
  Count := 0;
  Size := 1;
  PrintNode(Self);
end;

procedure TNode.RemoveStartedWith(const Wrd: string);
var w:string;
begin
 w:=wrd;
 RemoveStartedWithR(w);
end;

procedure TNode.RemoveStartedWithR(var wrd:string);
var w:TIndex;
begin
  w:=wrd[1];
  if length(wrd)=1 then FreeAndNil(FNext[w])
  else
    if FNext[w]<>nil then
       begin
        Delete(wrd,1,1);
        FNext[w].RemoveStartedWithR(wrd);
        if FNext[w].IsEmpty then
          FreeAndNil(FNext[w]);
       end;
end;

end.
