unit UTrie; { retrieval }
// ,     TTrie ()
interface

uses
  SysUtils,
  Classes,
  UTNode;

type
  TTrie = class
  private
    FRoot: TNode;
  public
    procedure Add(const Wrd: string);
    procedure Clear;
    constructor Create;
    destructor Destroy; override;
    procedure Print(S: TStrings);
    procedure RemoveStartedWith(const Wrd: string);
  end;

implementation

///  
procedure TTrie.Add(const Wrd: string);
  var
  i: integer;
  Cur: TNode;
begin
  if Wrd <> '' then
  begin
    if FRoot = nil then  FRoot:=TNode.Create;
    Cur := FRoot;
    for i := 1 to length(Wrd) do
    begin
      if Cur.FNext[Wrd[i]] = nil then
        Cur.FNext[Wrd[i]]:=TNode.Create;
      Cur := Cur.FNext[Wrd[i]];
    end;
    Cur.FPoint := true;
  end;
end;

///  
procedure TTrie.Clear;
begin
  FreeAndNil(FRoot);
end;
/////// 
constructor TTrie.Create;
begin
  FRoot := nil;
end;
/////// 
destructor TTrie.Destroy;
begin
  Clear;
end;
/////   
procedure TTrie.Print(S: TStrings);
begin
  if FRoot <> nil then
    FRoot.Print(S)
  else
    S.Clear;
end;
/////////  ,    
procedure TTrie.RemoveStartedWith(const Wrd: string);
begin
  if FRoot <> nil then
   if Wrd = '' then
    Clear else
      begin
        FRoot.RemoveStartedWith(Wrd);
        if FRoot.IsEmpty then
          FreeAndNil(FRoot);
      end;
end;

end.
